// TRITEST_4

#include <SoftwareSerial.h>

SoftwareSerial mySerial =  SoftwareSerial(10, 11);

#define BUFFSIZ 100 
char buffer[BUFFSIZ];
char buffidx;
int ledPin = 13;        
int cnt;
boolean stringComplete = false;
String gga,rmc,instring1,instring2;
unsigned long lastTime;
unsigned long interval = 10000; // 10 Secs.
char mySerialByteIn;                               // Temporary variable
String mySerialReadBuffer = "";                    // Read/Write Buffer 1 for radio
boolean mySerialEnd = false;                       // Flag to indiacte End of radio String

///////////////////////////////////////////////////////////////
void readline(void) 
{
  char c;  
  buffidx = 0; // start at begninning
  while (1) {
      c=mySerial.read();
      if (c == -1)
      continue;
 // Serial.print(c);
    if (c == '\n')
        continue;
    if ((buffidx == BUFFSIZ-1) || (c == '\r')) {
        buffer[buffidx] = 0;
        return;
      }
    buffer[buffidx++]= c;
  }
}

///////////////////////////////////////////////////////////////
void readgps() 
{
  readline();
  instring1 = String(buffer); 
  if(instring1.substring(0,6)=="$GPRMC")
  {
  rmc = instring1;
  }
  instring2 = String(buffer); 
  if(instring2.substring(0,6)=="$GPGGA")
  {
  gga = instring2;
  }
}

//////////////////////////////////////////////////////
void setup() 
  { 
  mySerialReadBuffer.reserve(100);                  // Reserve 100 bytes for Serial message input
  pinMode(ledPin, OUTPUT);
  Serial.begin(9600);
  Serial.println("Start");
  mySerial.begin(9600);
  pinMode(ledPin, OUTPUT);
  pinMode(A0, INPUT_PULLUP);
  pinMode(A1, INPUT_PULLUP);
  pinMode(A2, INPUT_PULLUP);  
  pinMode(A3, INPUT_PULLUP);
  } 
 
/////////////////////////////////////////////////////////////// 
void loop() 
{ 
// --------------------------------------------------------------
// Mode1: Testbakenaussendung mit 10 Sec. Delayzeit 
// --------------------------------------------------------------
  if(digitalRead(A0)==LOW&&digitalRead(A1)==HIGH&&digitalRead(A2)==HIGH)
  {
  digitalWrite(ledPin, HIGH);
  Serial.print("Beacon_Test_");
  if(cnt<100) { Serial.print("0"); } 
  if(cnt<10) { Serial.print("0"); } 
  Serial.println(cnt);

  mySerial.print("Beacon_Test_");
  if(cnt<100) { mySerial.print("0"); } 
  if(cnt<10) { mySerial.print("0"); } 
  mySerial.println(cnt);
 
  cnt=cnt+1;
  if(cnt>999) { cnt=0; } 
  delay(100);
  digitalWrite(ledPin, LOW);
  delay(10000);
  }

// --------------------------------------------------------------
// Mode2: Repeater/Echo-Modus
// --------------------------------------------------------------
  else if(digitalRead(A0)==HIGH&&digitalRead(A1)==LOW&&digitalRead(A2)==HIGH)
  {
// Einlesen der vom Radio ueber Soft-UART empfangenen seriellen Daten 
    while (mySerial.available())                   // While Arduino's radio soft serial rx buffer has data
  {
    mySerialByteIn = mySerial.read();              // Store each character from rx buffer in byteIn
    mySerialReadBuffer += char(mySerialByteIn);    // Write each character of byteIn to radioReadBuffer
    if (mySerialByteIn == '\n')                    // At the end of the line
    {
    mySerialEnd = true;                            // Set radioEnd flag to true
    }
  }

// Hard and Soft-UART-Ausgabe empfangener Strings  
  if (mySerialEnd) 
  {                                             // Check to see if SerialEnd flag is true
    mySerial.print(mySerialReadBuffer);         // Transmit non-command message via soft serial
    Serial.println(mySerialReadBuffer);         // watch non-command message via hard UART
    mySerialReadBuffer = "";                    // Clear Buffer
    mySerialEnd = false;                        // Reset flag
  }
}

// --------------------------------------------------------------
// Mode3: GPS-Selektion GGA/RMC in Intervallen gem. Wert in Variable "interval"
// --------------------------------------------------------------
  else if(digitalRead(A0)==HIGH&&digitalRead(A1)==HIGH&&digitalRead(A2)==LOW)
  {
  readgps();
// Serial.println(millis()-lastTime);  
    if(millis()-lastTime>interval)
    { lastTime = millis(); 
    digitalWrite(ledPin, LOW);
    Serial.println(gga);
  if(digitalRead(A3)==HIGH)
  { Serial.println(rmc); } 
    delay(100);
    digitalWrite(ledPin, HIGH);
   }
 }
}

  
